﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.31
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private tv As UOENowTreeView
	Public BANano As BANano
End Sub

' convert a json string to a list
Sub Json2List(strValue As String) As List
	Dim lst As List
	lst.Initialize
	lst.clear
	If strValue.Length = 0 Then
		Return lst
	End If
	Try
		Dim parser As BANanoJSONParser
		parser.Initialize(strValue)
		Return parser.NextArray
	Catch
		Return lst
	End Try
End Sub

Sub Initialize
	BANano.GetElement("#body").empty
	BANano.LoadLayout("#body", "vTree")
	BANano.GetElement("#body").SetStyle($"{"padding": "8px"}"$)
	
'	'use data source
'	tv.imageUrlField = "flagUrl"
'	Dim data As String = $"[{"id":1,"text":"Asia","population":null,"flagUrl":null,"checked":false,"hasChildren":false,"children":[{"id":2,"text":"China","population":1373541278,"flagUrl":"https://code.gijgo.com/flags/24/China.png","checked":false,"hasChildren":false,"children":[]},{"id":3,"text":"Japan","population":126730000,"flagUrl":"https://code.gijgo.com/flags/24/Japan.png","checked":false,"hasChildren":false,"children":[]},{"id":4,"text":"Mongolia","population":3081677,"flagUrl":"https://code.gijgo.com/flags/24/Mongolia.png","checked":false,"hasChildren":false,"children":[]}]},{"id":5,"text":"North America","population":null,"flagUrl":null,"checked":false,"hasChildren":false,"children":[{"id":6,"text":"USA","population":325145963,"flagUrl":"https://code.gijgo.com/flags/24/United%20States%20of%20America(USA).png","checked":false,"hasChildren":false,"children":[{"id":7,"text":"California","population":39144818,"flagUrl":null,"checked":false,"hasChildren":false,"children":[]},{"id":8,"text":"Florida","population":20271272,"flagUrl":null,"checked":false,"hasChildren":false,"children":[]}]},{"id":9,"text":"Canada","population":35151728,"flagUrl":"https://code.gijgo.com/flags/24/canada.png","checked":false,"hasChildren":false,"children":[]},{"id":10,"text":"Mexico","population":119530753,"flagUrl":"https://code.gijgo.com/flags/24/mexico.png","checked":false,"hasChildren":false,"children":[]}]},{"id":11,"text":"South America","population":null,"flagUrl":null,"checked":false,"hasChildren":false,"children":[{"id":12,"text":"Brazil","population":207350000,"flagUrl":"https://code.gijgo.com/flags/24/brazil.png","checked":false,"hasChildren":false,"children":[]},{"id":13,"text":"Argentina","population":43417000,"flagUrl":"https://code.gijgo.com/flags/24/argentina.png","checked":false,"hasChildren":false,"children":[]},{"id":14,"text":"Colombia","population":49819638,"flagUrl":"https://code.gijgo.com/flags/24/colombia.png","checked":false,"hasChildren":false,"children":[]}]},{"id":15,"text":"Europe","population":null,"flagUrl":null,"checked":false,"hasChildren":false,"children":[{"id":16,"text":"England","population":54786300,"flagUrl":"https://code.gijgo.com/flags/24/england.png","checked":false,"hasChildren":false,"children":[]},{"id":17,"text":"Germany","population":82175700,"flagUrl":"https://code.gijgo.com/flags/24/germany.png","checked":false,"hasChildren":false,"children":[]},{"id":18,"text":"Bulgaria","population":7101859,"flagUrl":"https://code.gijgo.com/flags/24/bulgaria.png","checked":false,"hasChildren":false,"children":[]},{"id":19,"text":"Poland","population":38454576,"flagUrl":"https://code.gijgo.com/flags/24/poland.png","checked":false,"hasChildren":false,"children":[]}]}]"$
'	Dim countries As List = Json2List(data)
'	tv.SetDataSource(countries)
'	tv.refresh
'	Return
	
	'define treeview details
	tv.AddNode("","0","Mbanga Family","http://gijgo.com/content/icons/world-icon.png","", CreateMap("population":"1200M","elders":"8000"))
	tv.AddNode("0","1","Felicia Mtshemla","","",Null)
	tv.AddNode("1","2","Sandra Mbanga","","",Null)
	tv.AddNode("2","3","My Big Brother","","",Null)
	tv.AddNode("2","4","Mashy","","",Null)
	tv.AddNode("4","6","Ozzie","","",Null)
	tv.AddNode("4","7","Ernesto","","",Null)
	tv.AddNode("4","8","My 2nd Daughter","","",Null)
	tv.AddNode("2","5","My Little Sister","","",Null)
	tv.AddNode("4","9","Unknown Child","","",Null)
'	'add a new node with data
	tv.SetText("5", "Mbasa")
	tv.SetData("5", CreateMap("surname":"Mbanga","Age":"43"))
	tv.SetText("3","Gqabs")
	tv.SetBackgroundColor("2","red")
	tv.SetColor("0", "orange")
	tv.AddNode("0","11","Icon","","fa fa-folder",Null)
	tv.SetIcon("5", "fa fa-folder")
	tv.UpdateNode("8","Orio","","",CreateMap("age":"10"))
'	Log(tv.GetChildren("0"))
'	tv.Collapse("0")
'	tv.Disable("4")
'	Log(tv.GetAll)
'	tv.CheckAll
'	tv.ExpandAll
	tv.RemoveNode("9")
'	tv.UnCheck("0")
'	tv.SelectNode("0")
'	Dim md As Map = tv.GetDataById("0").Result
'	Log(md)
'	Dim md1 As Map = tv.GetDataByText("Xolani").Result
'	Log(md1)
End Sub

'Sub tv_CheckboxChange(e As BANanoEvent, node As Object, record As Object, state As Object)
'	Log("*checkboxchange*")
'	Log(e.Type)
'	Log(node)
'	Log(record)
'	Log(state)
'End Sub

Sub tv_Select (e As BANanoEvent, node As Object, id As Object)
	Dim rec As Map = tv.GetDataById(id).Result
	BANano.Alert(BANano.ToJson(rec))
End Sub


Sub tv_CheckboxChange(e As BANanoEvent, node As Object, record As Map, state As String)
	Select Case state
	Case "checked"
		BANano.Alert("Checked: " & BANano.ToJson(record))
	Case Else
		BANano.Alert("Unchecked: " & BANano.ToJson(record))
	End Select
End Sub

Sub tv_NodeDrop (e As BANanoEvent, id As String, parentId As String, orderNumber As String)
	Dim node As Map = tv.GetDataById(id).Result
	If parentId = Null Then parentId = ""
	node.Put("parentId",parentId)
	BANano.Alert(BANano.ToJson(node))
End Sub

Sub tv_NodeDataBound (e As BANanoEvent, node As Object, id As String, record As Map)
	Select Case id
	Case 1,5,7
		Dim el As BANanoElement = BANano.ToElement(node)
		el.SetStyle($"{"background-color": "red"}"$)
	End Select
End Sub