﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.31
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public BANano As BANano
	Private uoegrid As UOENowGridTable
	Private thetime As Timer
End Sub


Sub Initialize
	thetime.Initialize("thetime",5000) 
	thetime.Enabled = True
	BANano.GetElement("#body").empty
	BANano.LoadLayout("#body","vGrid2")
	BANano.GetElement("body").Append($"<div id="mytime">My Time</div><br><br>"$)
	BANano.GetElement("#body").SetStyle($"{"padding": "8px"}"$)
	
	'define the columns
	uoegrid.PrimaryKey = "id"
	uoegrid.AddColumn("id","#",uoegrid.COLUMN_TEXT, 56, False, uoegrid.ALIGN_CENTER)
	uoegrid.AddColumn("text","Name",uoegrid.COLUMN_TEXT, 0, True, uoegrid.ALIGN_LEFT)
	uoegrid.AddColumn("population","Population",uoegrid.COLUMN_TEXT,0,True,uoegrid.ALIGN_RIGHT)
	uoegrid.SetColumnRenderer("population","ColumnRenderer")
	uoegrid.AddColumn("flagUrl","Flag",uoegrid.COLUMN_IMAGE, 0, True, uoegrid.ALIGN_LEFT)
	uoegrid.AddColumn("checked","Checked?",uoegrid.COLUMN_CHECKBOX,100,False,uoegrid.ALIGN_CENTER)
	uoegrid.Refresh
End Sub


Sub thetime_Tick()
	BANano.GetElement("#mytime").SetText(DateTime.Time(DateTime.Now))
	'clear data and events
	Dim countries As List
	countries.Initialize
	countries.Add(CreateMap("id":1,"text":"Asia","population":Null,"flagUrl":Null,"checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":2,"text":"China","population":1373541278,"flagUrl":"https://code.gijgo.com/flags/24/China.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":3,"text":"Japan","population":126730000,"flagUrl":"https://code.gijgo.com/flags/24/Japan.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":4,"text":"Mongolia","population":-3081677,"flagUrl":"https://code.gijgo.com/flags/24/Mongolia.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":5,"text":"North America","population":Null,"flagUrl":Null,"checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":6,"text":"USA","population":325145963,"flagUrl":"https://code.gijgo.com/flags/24/United%20States%20of%20America(USA).png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":7,"text":"California","population":-39144818,"flagUrl":Null,"checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":8,"text":"Florida","population":20271272,"flagUrl":Null,"checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":9,"text":"Canada","population":35151728,"flagUrl":"https://code.gijgo.com/flags/24/canada.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":10,"text":"Mexico","population":-119530753,"flagUrl":"https://code.gijgo.com/flags/24/mexico.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":11,"text":"South America","population":Null,"flagUrl":Null,"checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":12,"text":"Brazil","population":207350000,"flagUrl":"https://code.gijgo.com/flags/24/brazil.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":13,"text":"Argentina","population":-43417000,"flagUrl":"https://code.gijgo.com/flags/24/argentina.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":14,"text":"Colombia","population":49819638,"flagUrl":"https://code.gijgo.com/flags/24/colombia.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":15,"text":"Europe","population":Null,"flagUrl":Null,"checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":16,"text":"England","population":-54786300,"flagUrl":"https://code.gijgo.com/flags/24/england.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":17,"text":"Germany","population":82175700,"flagUrl":"https://code.gijgo.com/flags/24/germany.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":18,"text":"Bulgaria","population":7101859,"flagUrl":"https://code.gijgo.com/flags/24/bulgaria.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":19,"text":"Poland","population":-38454576,"flagUrl":"https://code.gijgo.com/flags/24/poland.png","checked":False,"hasChildren":False))
	uoegrid.SetDataSource(countries).refresh
End Sub

Sub uoegrid_ColumnRenderer(value As Object, record As Map, cell As BANanoObject, displayEl As BANanoObject)
	If value = Null Then value = 0
	Dim de As BANanoElement = BANano.ToElement(displayEl)
	Dim svalue As String = uoegrid.NumeralFormat(value,"$(0.00 a)")
	de.SetText(svalue)
	If value < 0 Then
		de.SetStyle($"{"color":"red","font-weight": "bold"}"$)
		
	End If
End Sub