﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyPress (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
'#Event: Click (event As BANanoEvent)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)
#Event: CheckboxChange(e As BANanoEvent, node As Object, record As Map, state As String)
#Event: Select (e As BANanoEvent, node As Object, id as String)
#Event: NodeDrop (e As BANanoEvent, id As String, parentId As String, orderNumber As String)
#Event: NodeDataBound (e As BANanoEvent, node As Object, id As String, record As Map)


#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.
#DesignerProperty: Key: MarginLeft, DisplayName: Margin Left, FieldType: String, DefaultValue: , Description: Margin Left
#DesignerProperty: Key: MarginRight, DisplayName: Margin Right, FieldType: String, DefaultValue: , Description: Margin Right
#DesignerProperty: Key: MarginTop, DisplayName: Margin Top, FieldType: String, DefaultValue: , Description: Margin Top
#DesignerProperty: Key: MarginBottom, DisplayName: Margin Bottom, FieldType: String, DefaultValue: , Description: Margin Bottom
#DesignerProperty: Key: PaddingLeft, DisplayName: Padding Left, FieldType: String, DefaultValue: , Description: Padding Left
#DesignerProperty: Key: PaddingRight, DisplayName: Padding Right, FieldType: String, DefaultValue: , Description: Padding Right
#DesignerProperty: Key: PaddingTop, DisplayName: Padding Top, FieldType: String, DefaultValue: , Description: Padding Top
#DesignerProperty: Key: PaddingBottom, DisplayName: Padding Bottom, FieldType: String, DefaultValue: , Description: Padding Bottom
#DesignerProperty: Key: Width, DisplayName: Width, FieldType: String, DefaultValue: 400, Description: Width
#DesignerProperty: Key: CheckBoxes, DisplayName: Check Boxes, FieldType: Boolean, DefaultValue: False, Description: CheckBoxes
#DesignerProperty: Key: Border, DisplayName: Border, FieldType: Boolean, DefaultValue: True, Description: Border
#DesignerProperty: Key: CascadeCheck, DisplayName: Cascade Check, FieldType: Boolean, DefaultValue: True, Description: CascadeCheck
#DesignerProperty: Key: LazyLoading, DisplayName: Lazy Loading, FieldType: Boolean, DefaultValue: False, Description: LazyLoading
#DesignerProperty: Key: DragAndDrop, DisplayName: Drag And Drop, FieldType: Boolean, DefaultValue: False, Description: DragAndDrop
#DesignerProperty: Key: CascadeSelection, DisplayName: Cascade Selection, FieldType: Boolean, DefaultValue: False, Description: cascadeSelection
#DesignerProperty: Key: AutoLoad, DisplayName: Auto Load, FieldType: Boolean, DefaultValue: False, Description: AutoLoad
#DesignerProperty: Key: IconsLibrary, DisplayName: Icons Library, FieldType: String, Description: IconsLibrary, DefaultValue: fontawesome, List: materialicons|fontawesome
#DesignerProperty: Key: UILibrary, DisplayName: UI Library, FieldType: String, Description: UILibrary, DefaultValue: bootstrap4, List: materialdesign|bootstrap4
#DesignerProperty: Key: PrimaryKey, DisplayName: Primary Key, FieldType: String, Description: PrimaryKey, DefaultValue: id
#DesignerProperty: Key: SelectionType, DisplayName: Selection Type, FieldType: String, DefaultValue: single, List: single|multiple
#DesignerProperty: Key: CheckedField, DisplayName: Checked Field, FieldType: String, DefaultValue: checked, Description: Checked Field
#DesignerProperty: Key: ChildrenField, DisplayName: Children Field, FieldType: String, DefaultValue: children, Description: childrenField
#DesignerProperty: Key: DisabledField, DisplayName: Disabled Field, FieldType: String, DefaultValue: disabled, Description: disabledField
#DesignerProperty: Key: HasChildrenField, DisplayName: Has Children Field, FieldType: String, DefaultValue: hasChildren, Description: hasChildrenField
#DesignerProperty: Key: ImageCssClassField, DisplayName: Image Css Class Field, FieldType: String, DefaultValue: imageCssClass, Description: imageCssClassField
#DesignerProperty: Key: ImageHtmlField, DisplayName: Image Html Field, FieldType: String, DefaultValue: imageHtml, Description: imageHtmlField
#DesignerProperty: Key: ImageUrlField, DisplayName: Image Url Field, FieldType: String, DefaultValue: imageUrl, Description: imageUrlField
#DesignerProperty: Key: TextField, DisplayName: Text Field, FieldType: String, DefaultValue: text, Description: textField

Sub Class_Globals
	Public CheckedField As String = "checked"
	Public ChildrenField As String = "children"
	Public DisabledField As String = "disabled"
	Public HasChildrenField As String = "hasChildren"
	Public ImageCssClassField As String = "imageCssClass"
	Public ImageHtmlField As String = "imageHtml"
	Public ImageUrlField As String = "imageUrl"
	Public TextField As String = "text"
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
	Public Width As String = "400"
	Public CheckBoxes As Boolean = False
	Public Banano As BANano
	Public Border As Boolean = True
	Public CascadeCheck As Boolean = True
	Public CascadeSelection As Boolean = False
	Public LazyLoading As Boolean = False
	Private PrimaryKey As String = "id"
	Public DragAndDrop As Boolean = False
	Private SelectionType As String = "single"
	Private ExpandIcon As String = ""
	Private CollapseIcon As String = ""
	Private mCallBack As Object 'ignore
	Private mEventName As String 'ignore
	Private mClasses As String = ""
	Private mStyle As String = ""
	Public MarginLeft As String = ""
	Public MarginRight As String = ""
	Public MarginTop As String = ""
	Public MarginBottom As String = ""
	Public PaddingLeft As String = ""
	Public PaddingRight As String = ""
	Public PaddingTop As String = ""
	Public PaddingBottom As String = ""
	Private tree As BANanoObject
	Public AutoLoad As Boolean = False
	Private DataSource As List
	Public IconsLibrary As String = "fontawesome"
	Public UILibrary As String = "bootstrap4"
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(CallBack As Object, Name As String, EventName As String)
	mName = Name
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
End Sub

' this is the place where you create the view in html and run initialize javascript
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target
	If Props <> Null Then
		mClasses = Props.Get("Classes")
		mStyle = Props.Get("Style")
		MarginLeft = Props.Get("MarginLeft")
		MarginRight = Props.Get("MarginRight")
		MarginTop = Props.Get("MarginTop")
		MarginBottom = Props.Get("MarginBottom")
		PaddingLeft = Props.Get("PaddingLeft")
		PaddingRight = Props.Get("PaddingRight")
		PaddingTop = Props.Get("PaddingTop")
		PaddingBottom = Props.Get("PaddingBottom")
		Width = Props.Get("Width")
		CheckBoxes = Props.Get("CheckBoxes")
		Border = Props.Get("Border")
		CascadeCheck = Props.Get("CascadeCheck")
		LazyLoading = Props.Get("LazyLoading")
		DragAndDrop = Props.Get("DragAndDrop")
		CascadeSelection = Props.Get("CascadeSelection")
		AutoLoad = Props.Get("AutoLoad")
		IconsLibrary = Props.Get("IconsLibrary")
		UILibrary = Props.Get("UILibrary")
		PrimaryKey = Props.Get("PrimaryKey")
		SelectionType = Props.Get("SelectionType")
		CheckedField = Props.Get("CheckedField")
		ChildrenField = Props.Get("ChildrenField")
		DisabledField = Props.Get("DisabledField")
		HasChildrenField = Props.Get("HasChildrenField")
		ImageCssClassField = Props.Get("ImageCssClassField")
		ImageHtmlField = Props.Get("ImageHtmlField")
		ImageUrlField = Props.Get("ImageUrlField")
		TextField = Props.Get("TextField")
	End If
	
	Dim exStyle As String = BuildExStyle
	mElement = mTarget.Append($"<div id="${mName}" class="${mClasses}" style="${exStyle}${mStyle}"></div>"$).Get("#" & mName)
	
	DataSource.Initialize 
End Sub

Sub SetDataSource(data As List)
	DataSource = data
End Sub

'set the options for the tree
Sub Refresh
	If tree <> Null Then Destroy
	Select Case IconsLibrary
		Case "materialicons"
			ExpandIcon = $"<i class="material-icons">keyboard_arrow_right</i>"$
			CollapseIcon = $"<i class="material-icons">keyboard_arrow_down</i>"$
		Case "fontawesome"
			ExpandIcon = $"<i class="fa fa-chevron-right"></i>"$
			CollapseIcon = $"<i class="fa fa-chevron-down"></i>"$
	End Select
	
	Public CheckedField As String = "checked"
	Public ChildrenField As String = "children"
	Public DisabledField As String = "disabled"
	Public HasChildrenField As String = "hasChildren"
	Public ImageCssClassField As String = "imageCssClass"
	Public ImageHtmlField As String = "imageHtml"
	Public ImageUrlField As String = "imageUrl"
	Public TextField As String = "text"
	
	Dim opt As Map = CreateMap("iconsLibrary": IconsLibrary, _
	"checkedField":CheckedField, _
	"childrenField":ChildrenField, _
	"disabledField":DisabledField, _
	"hasChildrenField":HasChildrenField, _
	"imageCssClassField":ImageCssClassField, _
	"imageHtmlField":ImageHtmlField, _
	"imageUrlField":ImageUrlField, _
	"textField":TextField, _
	"uiLibrary": UILibrary, _
	"checkboxes": CheckBoxes, _
	"border": Border, _
	"cascadeCheck": CascadeCheck, _
	"lazyLoading": LazyLoading, _
	"primaryKey": PrimaryKey, _
	"dragAndDrop": DragAndDrop, _
	"selectionType": SelectionType, _
	"autoLoad": AutoLoad, _
	"cascadeSelection": CascadeSelection, _
	"dataSource": DataSource)
	Dim icn As Map
	icn.Initialize
	icn.Put("expand", ExpandIcon)
	icn.Put("collapse", CollapseIcon)
	opt.Put("icons", icn)
	'initialize jquery
	Dim bo As BANanoObject
	bo.Initialize("$")
	tree = bo.Selector($"#${mName}"$)
	tree.RunMethod("tree", Array(opt))
	
	'add events
	'tree.on('enable', function (e, node) {
	'alert(node.text() + ' is enabled.');
	'});
	'tree.on('disable', function (e, node) {
	'alert(node.text() + ' is disabled.');
	'});
	'tree.on('expand', function (e, node, id) {
	'alert('expand is fired.');
	'});
	'tree.on('select', function (e, node, id) {
	'alert('select is fired for node with id=' + id);
	'});
	'tree.on('unselect', function (e, node, id) {
	'alert('unselect is fired for node with id=' + id);
	'});
	'tree.on('checkboxChange', function (e, $node, record, state) {
	'alert('The new state of record ' + record.text + ' is ' + state);
	'});
	Dim e, node, record, id, state As Map
	Dim parentId, orderNumber As Map
	tree.RunMethod("bind", Array("checkboxChange", Banano.Callback(mCallBack, mEventName & "_checkboxchange", Array(e, node, record, state))))
	tree.RunMethod("bind", Array("select", Banano.Callback(mCallBack, mEventName & "_select", Array(e, node, id))))
	'tree.RunMethod("bind", Array("unselect", Banano.Callback(mCallBack, mEventName & "_select", Array(e, node, id))))
	tree.RunMethod("bind", Array("nodeDrop", Banano.Callback(mCallBack, mEventName & "_nodedrop", Array(e, id, parentId, orderNumber))))
	tree.RunMethod("bind", Array("nodeDataBound", Banano.Callback(mCallBack, mEventName & "_nodedatabound", Array(e, node, id, record))))
End Sub


Sub ToString As String
	Dim exStyle As String = BuildExStyle
	Dim script As String = $"<div id="${mName}" class="${mClasses}" style="${exStyle}${mStyle}"></div>"$
	Return script
End Sub


Sub AddToParent(targetID As String)
	mTarget = Banano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
	Refresh
End Sub

public Sub Remove()
	mTarget.Empty
	Banano.SetMeToNull
End Sub

public Sub Trigger(event As String, params() As String)
	If mElement <> Null Then
		mElement.Trigger(event, params)
	End If
End Sub

private Sub BuildExStyle() As String
	Dim sb As StringBuilder
	sb.Initialize
	If MarginLeft <> "" Then sb.Append("margin-left: " & MarginLeft & ";")
	If MarginRight <> "" Then sb.Append("margin-right: " & MarginRight & ";")
	If MarginTop <> "" Then sb.Append("margin-top: " & MarginTop & ";")
	If MarginBottom <> "" Then sb.Append("margin-bottom: " & MarginBottom & ";")
	If PaddingLeft <> "" Then sb.Append("padding-left: " & PaddingLeft & ";")
	If PaddingRight <> "" Then sb.Append("padding-right: " & PaddingRight & ";")
	If PaddingTop <> "" Then sb.Append("padding-top: " & PaddingTop & ";")
	If PaddingBottom <> "" Then sb.Append("padding-bottom: " & PaddingBottom & ";")
	Return sb.ToString
End Sub

public Sub setClasses(Classes As String)
	If mElement <> Null Then
		mElement.AddClass(Classes)
	End If
	mClasses = Classes
End Sub

public Sub getClasses() As String
	Return mClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	If mElement <> Null Then
		mElement.SetStyle(Style)
	End If
	mStyle = Style
End Sub

public Sub getStyle() As String
	Return mStyle
End Sub

'add node
Sub AddNode(parentID As String, pk As String, Text As String, ImgURL As String, Icon As String, Tag As Map)
	If tree = Null Then Refresh
	'define the node to add
	Dim nod As Map = CreateMap("id":pk,"text":Text)
	'if the png is specified
	If ImgURL <> "" Then 
		nod.Put(ImageUrlField, ImgURL)
	End If
	'if icon is specified
	If Icon <> "" Then
		Dim sIcon As String = ""
		Select Case IconsLibrary
		Case "materialicons"
			sIcon = $"<i class="material-icons">${Icon}</i>"$
		Case "fontawesome"
			sIcon = $"<i class="${Icon}"></i>"$
		End Select
		nod.Put(ImageHtmlField, sIcon)
	End If
	'the node as details
	If Tag <> Null Then
		For Each strKey As String In Tag.Keys
			Dim strVal As Object = Tag.Get(strKey)
			nod.Put(strKey,strVal)
		Next
	End If	
	If parentID = "" Then
		tree.RunMethod("addNode",Array(nod))
	Else
		Dim prnt As BANanoObject = GetNodeById(parentID)
		If prnt <> Null Then
			tree.RunMethod("addNode",Array(nod,prnt))
		End If
	End If
End Sub

'get data by id
Sub GetDataById(pk As String) As BANanoObject
	Return tree.RunMethod("getDataById", Array(pk))
End Sub

'get node by id
Sub GetNodeById(pk As String) As BANanoObject
	Return tree.RunMethod("getNodeById", Array(pk))
End Sub

'get node by text
Sub GetNodeByText(pk As String) As BANanoObject
	Return tree.RunMethod("getNodeByText", Array(pk))
End Sub

'get data by text
Sub GetDataByText(nodeText As String) As BANanoObject
	Return tree.RunMethod("getDataByText", Array(nodeText))
End Sub

'set text of node
Sub SetText(pk As String, Text As String)
	Dim nod As BANanoObject = GetDataById(pk)
	If nod <> Null Then
		nod.SetField("text", Text)
		tree.RunMethod("updateNode", Array(pk, nod))
	End If
End Sub

'set icon of node
Sub SetIcon(pk As String, Icon As String)
	Dim nod As BANanoObject = GetDataById(pk)
	If nod <> Null Then
		Dim sIcon As String = ""
		Select Case IconsLibrary
		Case "materialicons"
			sIcon = $"<i class="material-icons">${Icon}</i>"$
		Case "fontawesome"
			sIcon = $"<i class="${Icon}"></i>"$
		End Select
		nod.SetField(ImageHtmlField, sIcon)
		tree.RunMethod("updateNode", Array(pk, nod))
	End If
End Sub

'set image of node
Sub SetImage(pk As String, ImageURL As String)
	Dim nod As BANanoObject = GetDataById(pk)
	If nod <> Null Then
		nod.SetField(ImageUrlField, ImageURL)
		tree.RunMethod("updateNode", Array(pk, nod))
	End If
End Sub

'set data for Node
Sub SetData(pk As String, Tag As Map)
	Dim nod As BANanoObject = GetDataById(pk)
	If nod <> Null Then
		If Tag <> Null Then
			For Each strKey As String In Tag.Keys
				Dim strVal As Object = Tag.Get(strKey)
				nod.SetField(strKey, strVal)
			Next
		End If
		tree.RunMethod("updateNode", Array(pk, nod))
	End If
End Sub

'update node
Sub UpdateNode(pk As String, Text As String, ImgURL As String, Icon As String, Tag As Map)
	Dim nod As BANanoObject = GetDataById(pk)
	If nod <> Null Then
		nod.SetField("text", Text)
		If Tag <> Null Then
			For Each strKey As String In Tag.Keys
				Dim strVal As Object = Tag.Get(strKey)
				nod.SetField(strKey, strVal)
			Next
		End If
		Dim sIcon As String = ""
		Select Case IconsLibrary
		Case "materialicons"
			sIcon = $"<i class="material-icons">${Icon}</i>"$
		Case "fontawesome"
			sIcon = $"<i class="${Icon}"></i>"$
		End Select
		If ImgURL.Length > 0 Then nod.SetField(ImageUrlField, sIcon)
		If Icon.Length > 0 Then nod.SetField(ImageHtmlField, ImgURL)
		tree.RunMethod("updateNode", Array(pk, nod))
	End If
End Sub

'get children
Sub GetChildren(pk As String) As List
	Return tree.RunMethod("getChildren", Array(GetNodeById(pk)))
End Sub

'get checkedNodes
Sub GetCheckedNodes() As List
	Dim snodes As List
	snodes.Initialize 
	If CheckBoxes = False Then Return snodes
	snodes = tree.RunMethod("getCheckedNodes","")
	Return snodes
End Sub

'get selected nodes
Sub GetSelections() As List
	Return tree.RunMethod("getSelections","")
End Sub

'get all ids
Sub GetAll() As String
	Dim bo As BANanoObject = tree.RunMethod("getAll","")
	Return Banano.ToJson(bo.Result)
End Sub

'remove a node
Sub RemoveNode(pk As String)
	tree.RunMethod("removeNode", GetNodeById(pk))
End Sub

'check a node
Sub Check(pk As String)
	If CheckBoxes = False Then Return
	tree.RunMethod("check", Array(GetNodeById(pk)))
End Sub

'uncheck a node
Sub UnCheck(pk As String)
	If CheckBoxes = False Then Return
	tree.RunMethod("uncheck", Array(GetNodeById(pk)))
End Sub

'select a node
Sub SelectNode(pk As String)
	tree.RunMethod("select", Array(GetNodeById(pk)))
End Sub

'unselect a node
Sub UnSelectNode(pk As String)
	tree.RunMethod("unselect", Array(GetNodeById(pk)))
End Sub

'ExpandAll nodes
Sub ExpandAll()
	tree.RunMethod("expandAll", "")
End Sub

'reload tree view
Sub Reload()
	tree.RunMethod("reload", "")
End Sub

'collapse all nodes
Sub CollapseAll()
	tree.RunMethod("collapseAll", "")
End Sub

'checkAll nodes
Sub CheckAll()
	If CheckBoxes = False Then Return
	tree.RunMethod("checkAll", "")
End Sub

'UncheckAll nodes
Sub UnCheckAll()
	If CheckBoxes = False Then Return
	tree.RunMethod("uncheckAll", "")
End Sub

'set background color of node
Sub SetBackgroundColor(pk As String, color As String)
	Dim els As String = $"{"background-color":"${color}"}"$
	Banano.ToElement(GetNodeById(pk)).SetStyle(els)
End Sub

'set color of the node
Sub SetColor(pk As String, color As String)
	Dim els As String = $"{"color":"${color}"}"$
	Banano.ToElement(GetNodeById(pk)).SetStyle(els)
End Sub

'Expand a node
Sub Expand(pk As String)
	tree.RunMethod("expand", Array(GetNodeById(pk)))
End Sub

'collapse a node
Sub Collapse(pk As String)
	tree.RunMethod("collapse", Array(GetNodeById(pk)))
End Sub

'enable a node
Sub Enable(pk As String)
	tree.RunMethod("enable", Array(GetNodeById(pk)))
End Sub

'disable a node
Sub Disable(pk As String)
	tree.RunMethod("disable", Array(GetNodeById(pk)))
End Sub

'destroy the tree
Sub Destroy
	tree.runmethod("destroy",Null)
End Sub

'remove children
Sub RemoveChildren(parentID As String)
	Try
		'get all children
		Dim children As List = GetChildren(parentID)
		For Each strChild As String In children
			RemoveNode(strChild)
		Next
	Catch
		Log("Error removing children")
	End Try
End Sub


'get the data
Sub GetData(pk As String) As Map
	Dim bo As BANanoObject = GetDataById(pk)
	Dim dm As Map = bo.Result
	Return dm
End Sub