﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.31
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public BANano As BANano
	Private uoegrid As UOENowGridTable
	Private uoegrid1 As UOENowGridTable
	Public JQuery As BANanoObject
End Sub

Sub Initialize
	JQuery.Initialize("$") 
	BANano.GetElement("#body").empty
	BANano.LoadLayout("#body","vGrid")
	BANano.GetElement("#body").SetStyle($"{"padding": "8px"}"$)
	BANano.GetElement("#body").Append("<br><br>")
	BANano.GetElement("#body").Append($"<button id="countvisible" class="btn btn-default">Count Visible Records</button>"$)
	BANano.GetElement("#body").Append($"<button id="countall" class="btn btn-default">Count All Records</button>"$)
	BANano.GetElement("#body").Append($"<button id="getsel" class="btn btn-default">Get Selected</button>"$).Append("<br><br>")
	BANano.GetElement("#body").Append($"<button id="csv" class="gj-button-md btn btn-default">CSV</button>"$)
	BANano.GetElement("#body").Append($"<button id="getupdates" class="gj-button-md btn btn-default">Get Updates</button>"$)
		
	BANano.GetElement("#countvisible").HandleEvents("click",Me,"countvisible_click")
	BANano.GetElement("#countall").HandleEvents("click",Me,"countall_click")
	BANano.GetElement("#getsel").HandleEvents("click",Me,"getsel_click")
	BANano.GetElement("#csv").HandleEvents("click",Me,"csv_click")
	BANano.GetElement("#getupdates").HandleEvents("click",Me,"updates_click")
	
	'define the columns
	uoegrid.PrimaryKey = "id"
	uoegrid.AddColumn("id","#",uoegrid.COLUMN_TEXT, 56, False, uoegrid.ALIGN_CENTER)
	uoegrid.SetColumnFilterable("id", False)
	uoegrid.AddColumn("Name","Name",uoegrid.COLUMN_TEXT, 0, True, uoegrid.ALIGN_LEFT)
	'make the column header italic
	uoegrid.SetColumnItalic("Name")
	'set the column tooltip
	uoegrid.SetColumnToolTip("Name","Full name of player.")
	uoegrid.AddColumn("CountryName","Country Name",uoegrid.COLUMN_DROPDOWN,200,True,uoegrid.ALIGN_LEFT)
	uoegrid.AddColumn("PlaceOfBirth","Place of Birth",uoegrid.COLUMN_TEXT, 0, True, uoegrid.ALIGN_LEFT)
	uoegrid.AddColumn("DateOfBirth","Date of Birth", uoegrid.COLUMN_DATE,150,False,uoegrid.ALIGN_CENTER)
	'set the column data format
	uoegrid.SetColumnFormat("DateOfBirth","dd.mm.yyyy")
	'uoegrid.AddColumn("tmpl","Template", uoegrid.COLUMN_String,0,False,uoegrid.ALIGN_LEFT)
	uoegrid.AddColumn("IsActive","Active?",uoegrid.COLUMN_CHECKBOX,80,False,uoegrid.ALIGN_CENTER)
	uoegrid.SetColumnFilterable("IsActive", False)
	'add buttons
	uoegrid.AddIconEdit("edit","",68, uoegrid.ALIGN_CENTER)
	uoegrid.SetColumnClickEvent("edit",True)
	uoegrid.AddIconDelete("delete","",68, uoegrid.ALIGN_CENTER)
	uoegrid.SetColumnClickEvent("delete",True)
	uoegrid.AddIcon("ambulance","","fa fa-archive",68,uoegrid.ALIGN_CENTER)
	uoegrid.SetColumnClickEvent("ambulance",True)
	
	'set column editors
	uoegrid.SetColumnEditors(Array("Name","PlaceOfBirth","DateOfBirth","IsActive","CountryName"))
	'add more column events
	uoegrid.SetColumnEvent("Name","mouseenter",True)
	uoegrid.SetColumnEvent("Name","mouseleave",True)
	uoegrid.SetColumnEvent("id","click",True)
	
	'** EDITOR COLUMNS ONLY
	'*make a column edit only mode
	'make column read only
	'uoegrid.SetColumnReadOnly(Array("DateOfBirth"))
	'*** CLOSE EDITOR COLUMNS
	'set column filterable
	'uoegrid.SetColumnFilterable("tmpl",False)
	'set colum properties
	'uoegrid.SetColumnIcon("Edit","fa fa-pencil")
	'set the column template
	'uoegrid.SetColumnTmpl("tmpl","{Name} is born in {PlaceOfBirth}")
	'uoegrid.SetColumnToolTip("Edit","Click here to update the candidate details.")
	'set the column name
	'uoegrid.SetColumnName("PlaceOfBirth", "Birth Place")
	'set a column to group by
	'uoegrid.DetailTemplate = $"<div style="text-align: left"><b>Place Of Birth:</b> {PlaceOfBirth}</div>"$
	'uoegrid.SetColumnGroupBy("CountryName")
	
	'define data source for countries, the name SHOULD BE 'text'
	Dim countries As List
	countries.Initialize
	countries.Add(CreateMap("id":18, "text": "Bulgaria"))
	countries.Add(CreateMap("id":12, "text": "Brazil"))
	countries.Add(CreateMap("id":16, "text": "England"))
	countries.Add(CreateMap("id":17, "text": "Germany"))
	countries.Add(CreateMap("id":19, "text": "Poland"))
	countries.Add(CreateMap("id":14, "text": "Colombia"))
	countries.Add(CreateMap("id":15, "text": "South Africa"))
	uoegrid.SetColumnDataSource("CountryName", countries, "id", "CountryID")
		
	'add the datasource
	Dim dataSource As List
	dataSource.Initialize 
	dataSource.Add(CreateMap("id": 1, "Name": "Hristo Stoichkov", "PlaceOfBirth": "Plovdiv, Bulgaria","DateOfBirth":"/Date(-122227200000)/","IsActive":False,"CountryID":18,"CountryName": "Bulgaria"))
	dataSource.Add(CreateMap("id": 2, "Name": "Ronaldo Luis Nazario de Lima", "PlaceOfBirth": "Rio de Janeiro, Brazil", "DateOfBirth":"/Date(211878000000)/","IsActive":False,"CountryID":12,"CountryName": "Brazil"))
	dataSource.Add(CreateMap("id": 3, "Name": "David Platt", "PlaceOfBirth": "Chadderton, Lancashire, England","DateOfBirth":"/Date(-112122000000)/","IsActive":False,"CountryID":16,"CountryName": "England"))
	dataSource.Add(CreateMap("id": 4, "Name": "Manuel Neuer", "PlaceOfBirth": "Gelsenkirchen, West Germany", "DateOfBirth":"/Date(512294400000)/", "IsActive":True, "CountryID":17, "CountryName": "Germany"))
	dataSource.Add(CreateMap("id": 5, "Name": "James Rodríguez", "PlaceOfBirth": "Cúcuta, Colombia", "IsActive":True, "CountryName": "Colombia","DateOfBirth":"/Date(349689600000)/","CountryID":14))
	dataSource.Add(CreateMap("id": 6, "Name": "Dimitar Berbatov", "PlaceOfBirth": "Blagoevgrad, Bulgaria", "IsActive":False, "CountryName": "Bulgaria","DateOfBirth":"/Date(349689600000)/","CountryID":18))
	dataSource.Add(CreateMap("id": 7, "Name": "Robert Lewandowski", "PlaceOfBirth": "Warsaw, Poland", "DateOfBirth":"/Date(588150000000)/", "CountryID":19, "CountryName": "Poland", "IsActive":True))
	uoegrid.SetDataSource(dataSource).Refresh
	'uoegrid.SetDataSource("https://gijgo.com/Players/Get")
	'add a row dynamically
	uoegrid.AddRow(CreateMap("id": 8, "Name": "Mashy", "PlaceOfBirth": "East London, Eastern Cape", "DateOfBirth":"/Date(588150000000)/", "CountryID":15, "CountryName": "South Africa", "IsActive":True))
	
	
	'hide a column via code
	'uoegrid.HideColumn(Array("PlaceOfBirth"))
	'show a column via code
	'uoegrid.ShowColumn("Info")
	
	'get row data by position
	'Dim res As Map = uoegrid.GetByPos(3)
	'Log(res)
	'Dim vr As List = uoegrid.GetRows
	'Log(vr) 
	'Dim resx As Map = uoegrid.GetById(4)
	'Log(resx)
	'uoegrid.SearchFor("Dimitar")
	'uoegrid.RemoveRow("1")
	'uoegrid.SetSelected(2)
	'uoegrid.SelectAll
	'uoegrid.UnSelectAll
	'update a row
	'uoegrid.UpdateRow(CreateMap("id":1,"Name":"Mashy Mbanga"))
	'uoegrid.CollapseAll
	'***Log(uoegrid.GetCSV)
End Sub

' convert a json string to a list
Sub Json2List(strValue As String) As List
	Dim lst As List
	lst.Initialize
	lst.clear
	If strValue.Length = 0 Then
		Return lst
	End If
	Try
		Dim parser As BANanoJSONParser
		parser.Initialize(strValue)
		Return parser.NextArray
	Catch
		Return lst
	End Try
End Sub

Sub uoegrid_id_click(e As BANanoEvent)
	Dim record As Map = uoegrid.GetRecordFromEvent(e)
	BANano.Alert(BANano.ToJson(record))
End Sub

'get a jquery element
Sub JQElement(elID As String) As BANanoElement
	Dim bo As BANanoObject = JQuery.Selector(elID)
	Dim el As BANanoElement = BANano.ToElement(bo)
	Return el
End Sub

Sub uoegrid_name_mouseenter(e As BANanoEvent)
	e.StopPropagation
	Dim el As BANanoElement = JQElement(e.CurrentTarget)
	el.SetStyle($"{"background-color":"red"}"$)
End Sub

Sub uoegrid_name_mouseleave(e As BANanoEvent)
	e.StopPropagation
	Dim el As BANanoElement = JQElement(e.CurrentTarget)
	el.SetStyle($"{"background-color":""}"$)
End Sub

Sub updates_click(e As BANanoEvent)
	Dim res As List = uoegrid.GetChanges
	'Log(res)
End Sub

Sub countvisible_click(e As BANanoEvent)
	BANano.Alert(uoegrid.CountVisible)
End Sub

Sub countall_click(e As BANanoEvent)
	BANano.Alert(uoegrid.CountAll)
End Sub

Sub getsel_click(e As BANanoEvent)
	Dim res As List = uoegrid.GetSelections
	'Log(res)
End Sub


Sub csv_click(e As BANanoEvent)
	uoegrid.DownloadCSV("players.csv")
End Sub

Sub uoegrid_edit(e As BANanoEvent)
	BANano.Alert("edit")
	Dim record As Map = uoegrid.GetRecordFromEvent(e)
	'Log(record)
End Sub

Sub uoegrid_delete(e As BANanoEvent)
	'get record from table
	Dim record As Map = uoegrid.GetRecordFromEvent(e)
	'get the id / primary key value
	Dim sid As String = record.Get("id")
	'get the name
	Dim sname As String = record.Get("Name")
	'confirm, you can add your own custom confirm box here
	Dim res As Boolean = BANano.Window.Confirm($"Are you sure that you want to delete player ${sname}?"$)
	'if yes remove the record from the grid
	If res Then 
		uoegrid.RemoveRow(sid)
		'process code to remove the record from the tb
	End If
End Sub

Sub uoegrid_ambulance(e As BANanoEvent)
	BANano.Alert("ambulance")
	Dim record As Map = uoegrid.GetRecordFromEvent(e)
	'Log(record)
End Sub



Sub uoegrid_CellDataChanged (e As BANanoEvent, cell As Object, column As Object, record As Map, newValue As String)
	'Log(cell)
	'Log(column)
	'Log(record)
	'Log(newValue)
End Sub

Sub uoegrid_RowDataChanged (e As BANanoEvent, id As String, record As Map)
End Sub


Sub uoegrid_RowDataBound (e As BANanoEvent, row As Object, id As String, record As Map)
	'Log(id)
	'Log(record)
End Sub

Sub uoegrid_RowRemoving (e As BANanoEvent, row As Object, id As String, record As Map)
	
	'get deleted record from the table
	'Log(record)
	'Log("row removed")
	'Log(record)
End Sub

Sub uoegrid_RowSelect (e As BANanoEvent, row As Object, id As String, record As Map)
	'Log("row selected")
	'Log(record)
End Sub

Sub uoegrid_RowUnSelect (e As BANanoEvent, row As Object, id As String, record As Map)
	'Log("row un-selected")
	'Log(record)
End Sub